version: "3"

volumes:
  pgdata:
    external: true

services:
  db:
    image: postgres:12
    restart: unless-stopped
    volumes:
      - pgdata:/var/lib/postgresql/12/main:Z
    ports:
      # This is the *published* port for postgres. 5432 is still the internal
      # port used for docker stuff, so 'server' uses that
      - 8001:5432
    environment:
      PGDATA: /var/lib/postgresql/12/main
      POSTGRES_USER: postgres
      POSTGRES_DB: kuachicups
      POSTGRES_PORT: 5432
      POSTGRES_PASSWORD: ${ENV_POSTGRES_PASSWORD}

  server:
    image: quasimal/kuachi.gg:latest
    restart: unless-stopped
    depends_on:
      - db
    environment:
      STATIC_DIR: /var/www
      STATIC_ENABLED: "true"
      MIGRATION_DIR: /db
      SQLX_OFFLINE: "true"
      ROCKET_ADDRESS: 0.0.0.0 # 127.0.0.1
      ROCKET_PORT: 8000
      PGUSER: postgres
      PGHOST: db
      PGPORT: 5432
      PGDATABASE: kuachicups
      PGPASSWORD: ${ENV_POSTGRES_PASSWORD}
      DB_URI: "postgresql://postgres:${ENV_POSTGRES_PASSWORD}@db:5432/kuachicups"
      DB_POOL_MIN_SIZE: 0
      DB_POOL_MAX_SIZE: 6
      DISCORD_REDIRECT_URL: https://kuachi.gg/logged_in
      RUST_LOG: kuachi=debug,rocket=info
      ROCKET_SECRET_KEY: ${ROCKET_SECRET_KEY}
      OAUTH2_CLIENT_ID: ${OAUTH2_CLIENT_ID}
      OAUTH2_CLIENT_SECRET: ${OAUTH2_CLIENT_SECRET}
      DISCORD_BOT_TOKEN: ${DISCORD_BOT_TOKEN}
    ports:
      - 8000:8000
    command: bash -c "cd /db; movine init; movine up; kuachicups-server"
